#ifndef ___EXTERNE_H__
#define ___EXTERNE_H__

#ifndef EXTERNE
#if defined (_WIN32) && !defined(LINUX)	//limine cas o on compile pour LINUX mais sous WIN
		#define EXTERNE extern "C" _declspec(dllexport)	//xxx 23/07/14 au lieu de import (bof)
	#else
		#define EXTERNE extern "C"
	#endif
#endif

#if !defined (_WIN32)
	#define _stdcall
#endif

///////////////////////////////////////////////
// Fonctions pour faire parler Kali
///////////////////////////////////////////////

//Message alpha (fonctionnement typique, synthse complte  partir du texte)
//texte est un pointeur sur le message  lire. Ce message peut tre constitu de
//plusieurs paragraphes, mais ne doit pas dpasser 5000 caractres.
EXTERNE short MessageKali(unsigned char* texte);
EXTERNE short _stdcall MessageKaliStd(unsigned char* texte);
EXTERNE short _stdcall MessageMultiKaliStd(short nK, unsigned char* texte);

//Message alpha sans analyse syntaxique ni prosodie
//Comme le prcdent, mais la voix ne prsente aucun relief
EXTERNE short MessSansAnalyseKali(unsigned char* texte);
EXTERNE short _stdcall MessSansAnalyseKaliStd(unsigned char* texte);
EXTERNE short _stdcall MessSansAnalyseMultiKaliStd(short nK, unsigned char* texte);

//Message phontique (parole ou chant)
//Comme le prcdent, mais le texte est phontique (codage fourni sur demande)
EXTERNE short MessPhonKali(unsigned char* texte);
EXTERNE short _stdcall MessPhonKaliStd(unsigned char* texte);
EXTERNE short _stdcall MessPhonMultiKaliStd(short nK, unsigned char* texte);

//Joue un fichier de type wave
EXTERNE void PlayWavKali(unsigned char* nomFichier);
EXTERNE void _stdcall PlayWavKaliStd(unsigned char* nomFichier);
EXTERNE void _stdcall PlayWavMultiKaliStd(short nK, unsigned char* nomFichier);

//Emet un bip
EXTERNE void BipKali(int frequence, int volume, int duree, int delai, int repetition);
EXTERNE void _stdcall BipKaliStd(int frequence, int volume, int duree, int delai, int repetition);
EXTERNE void _stdcall BipMultiKaliStd(short nK, int frequence, int volume, int duree, int delai, int repetition);

//Demande la valeur de l'index de lecture
//L'utilisation de l'index de lecture est dcrite dans l'annexe dveloppeur
EXTERNE short QueryIndexKali();
EXTERNE short _stdcall QueryIndexKaliStd();
EXTERNE short _stdcall QueryIndexMultiKaliStd(short nK);

//Retourne la position de lecture du message
EXTERNE short GetPosLecKali();
EXTERNE short _stdcall GetPosLecKaliStd();
EXTERNE short _stdcall GetPosLecMultiKaliStd(short nK);
//Et la suivante pour encadrer la partie en cours de lecture
EXTERNE short GetPosLecSuiKali();
EXTERNE short _stdcall GetPosLecSuiKaliStd();
EXTERNE short _stdcall GetPosLecSuiMultiKaliStd(short nK);

//Stop parole : arrte la lecture (effet immdiat)
EXTERNE short StopKali();
EXTERNE short _stdcall StopKaliStd();
EXTERNE short _stdcall StopMultiKaliStd(short nK);

////////////////////////////////////////////////////
// Fonctions de paramtrage de Kali
////////////////////////////////////////////////////

//Active (1) ou dsactive (0) la dtection automatique de langue
EXTERNE void SetDiagLangueKali(short diagLangue);
EXTERNE void _stdcall SetDiagLangueKaliStd(short diagLangue);
EXTERNE void _stdcall SetDiagLangueMultiKaliStd(short nK, short diagLangue);

//Demande l'tat du diagnostique de langue
EXTERNE short GetDiagLangueKali();
EXTERNE short _stdcall GetDiagLangueKaliStd();
EXTERNE short _stdcall GetDiagLangueMultiKaliStd(short nK);

//Active la langue choisie (1  n)
EXTERNE void SetLangueKali(short nLangue);
EXTERNE void _stdcall SetLangueKaliStd(short nLangue);
EXTERNE void _stdcall SetLangueMultiKaliStd(short nK, short nLangue);

//Demande la langue en cours
EXTERNE short GetLangueKali();
EXTERNE short _stdcall GetLangueKaliStd();
EXTERNE short _stdcall GetLangueMultiKaliStd(short nK);

//Demande le nombre de langues
EXTERNE short GetNbLanguesKali();
EXTERNE short _stdcall GetNbLanguesKaliStd();

//Demande le nom de la langue nLangue
EXTERNE char* GetNomLangueKali(short nLangue, char* nomLangue);
EXTERNE char* _stdcall GetNomLangueKaliStd(short nLangue, char* nomLangue);

//Demande le n de langue de la voix n
EXTERNE short _stdcall GetNLangueVoixKaliStd(short nVoix);

//Active la voix choisie (1  n)
EXTERNE void SetVoixKali(short nVoix);
EXTERNE void _stdcall SetVoixKaliStd(short nVoix);
EXTERNE void _stdcall SetVoixMultiKaliStd(short nK, short nVoix);

//Demande le numro de voix
EXTERNE short GetVoixKali();
EXTERNE short _stdcall GetVoixKaliStd();
EXTERNE short _stdcall GetVoixMultiKaliStd(short nK);

//Demande le nombre de voix
EXTERNE short GetNbVoixKali();
EXTERNE short _stdcall GetNbVoixKaliStd();

//Demande le nom de la voix nVoix
EXTERNE char* GetNomVoixKali(short nVoix, char* nomVoix);
EXTERNE char* _stdcall GetNomVoixKaliStd(short nVoix, char* nomVoix);

//Rgle le volume global
//Volume 0  15, par pas de 1.26 en amplitude (volume conseill : 12)
EXTERNE void SetVolumeKali(short volume);
EXTERNE void _stdcall SetVolumeKaliStd(short volume);
EXTERNE void _stdcall SetVolumeMultiKaliStd(short nK, short volume);

//Demande le volume global
EXTERNE short GetVolumeKali();
EXTERNE short _stdcall GetVolumeKaliStd();
EXTERNE short _stdcall GetVolumeMultiKaliStd(short nK);

//Rgle le dbit global
//Dbit -2  15 par pas de 1.12 (normal : 3  6)
EXTERNE void SetDebitKali(short debit);
EXTERNE void _stdcall SetDebitKaliStd(short debit);
EXTERNE void _stdcall SetDebitMultiKaliStd(short nK, short debit);

//Demande le dbit global
EXTERNE short GetDebitKali();
EXTERNE short _stdcall GetDebitKaliStd();
EXTERNE short _stdcall GetDebitMultiKaliStd(short nK);

//Rgle la hauteur globale
//Hauteur 0  15 par pas de 1.06 (demi-tons) (normale 4  6)
EXTERNE void SetHauteurKali(short hauteur);
EXTERNE void _stdcall SetHauteurKaliStd(short hauteur);
EXTERNE void _stdcall SetHauteurMultiKaliStd(short nK, short hauteur);

//Demande la hauteur globale
EXTERNE short GetHauteurKali();
EXTERNE short _stdcall GetHauteurKaliStd();
EXTERNE short _stdcall GetHauteurMultiKaliStd(short nK);

//Rgle le mode de lecture
//	0	littraire : mode normal, la ponctuation est interprte
//	1	intermdiaire : la ponctuation est prononce (ex : "virgule")
//	2	informatique : idem, mais tous les signes sont prononcs (ex : "apostrophe")
EXTERNE void SetModeLectureKali(short modeLecture);
EXTERNE void _stdcall SetModeLectureKaliStd(short modeLecture);
EXTERNE void _stdcall SetModeLectureMultiKaliStd(short nK, short modeLecture);

//Demande le mode de lecture
EXTERNE short GetModeLectureKali();
EXTERNE short _stdcall GetModeLectureKaliStd();
EXTERNE short _stdcall GetModeLectureMultiKaliStd(short nK);

//Rgle le mode compta (cas o les nombres sont groups par 3 chiffres)
//	0	le sparateur de milliers reste : les groupes de 3 chiffres restent spars
//	1	le sparateur de milliers est enlev : les groupes de 3 chiffres sont recolls
EXTERNE void SetComptaKali(short compta);
EXTERNE void _stdcall SetComptaKaliStd(short compta);
EXTERNE void _stdcall SetComptaMultiKaliStd(short nK, short compta);

//Demande si mode compta
EXTERNE short GetComptaKali();
EXTERNE short _stdcall GetComptaKaliStd();
EXTERNE short _stdcall GetComptaMultiKaliStd(short nK);

//Rgle le mode pelle
//	0	pellation normale (ex : "a", "b", "c")
//	1	pellation internationale (ex : "alpha", "bravo", "charlie")
EXTERNE void SetEpelleKali(short epelle);
EXTERNE void _stdcall SetEpelleKaliStd(short epelle);
EXTERNE void _stdcall SetEpelleMultiKaliStd(short nK, short epelle);

//Demande si mode pelle
EXTERNE short GetEpelleKali();
EXTERNE short _stdcall GetEpelleKaliStd();
EXTERNE short _stdcall GetEpelleMultiKaliStd(short nK);

//Rgle le mode articulation
//	0	articulation normale
//	1	hyper-articulation (e muets, in/un, dirse, liaisons+)
EXTERNE void SetArticuleKali(short articule);
EXTERNE void _stdcall SetArticuleKaliStd(short articule);
EXTERNE void _stdcall SetArticuleMultiKaliStd(short nK, short articule);

//Demande si mode hyper-articul
EXTERNE short GetArticuleKali();
EXTERNE short _stdcall GetArticuleKaliStd();
EXTERNE short _stdcall GetArticuleMultiKaliStd(short nK);

//Rgle l'option syntaxe
//	0	pas de calcul de syntaxe, aucune prosodie
//	1	mode normal, analyse syntaxique et prosodie
EXTERNE void SetSyntaxeKali(short syntaxe);
EXTERNE void _stdcall SetSyntaxeKaliStd(short syntaxe);
EXTERNE void _stdcall SetSyntaxeMultiKaliStd(short nK, short syntaxe);

//Demande si mode syntaxe
EXTERNE short GetSyntaxeKali();
EXTERNE short _stdcall GetSyntaxeKaliStd();
EXTERNE short _stdcall GetSyntaxeMultiKaliStd(short nK);

//Rgle la quantit de prosodie (0  15)
//	0	pas de prosodie
//	8	prosodie normale (la voix a du relief)
//	15	prosodie max (relief exagr)
EXTERNE void SetProsodieKali(short coefProso);
EXTERNE void _stdcall SetProsodieKaliStd(short coefProso);
EXTERNE void _stdcall SetProsodieMultiKaliStd(short nK, short coefProso);

//Demande la quantit de prosodie
EXTERNE short GetProsodieKali();
EXTERNE short _stdcall GetProsodieKaliStd();
EXTERNE short _stdcall GetProsodieMultiKaliStd(short nK);

//Rgle la dure des pauses (0  15)
//	0	pauses minimales	( utiliser plutt en lecture rapide)
//	8	pauses normales
//	15	pauses longues ( utiliser plutt en lecture lente)
//A noter : le dbit agit lui aussi sur la dure des pauses
EXTERNE void SetCoefPauseKali(short coefPause);
EXTERNE void _stdcall SetCoefPauseKaliStd(short coefPause);
EXTERNE void _stdcall SetCoefPauseMultiKaliStd(short nK, short coefPause);

//Demande la dure des pauses
EXTERNE short GetCoefPauseKali();
EXTERNE short _stdcall GetCoefPauseKaliStd();
EXTERNE short _stdcall GetCoefPauseMultiKaliStd(short nK);

//Rgle la quantit de prosodie naturelle/normalise (0/16  16/0)
EXTERNE void SetProsoNatKali(short coefProsoNat);
EXTERNE void _stdcall SetProsoNatKaliStd(short coefProsoNat);
EXTERNE void _stdcall SetProsoNatMultiKaliStd(short nK, short coefProsoNat);

//Demande la quantit de prosodie naturelle/normalise (0/16  16/0)
EXTERNE short GetProsoNatKali();
EXTERNE short _stdcall GetProsoNatKaliStd();
EXTERNE short _stdcall GetProsoNatMultiKaliStd(short nK);

//Demande la frquence moyenne de la voix courante
EXTERNE float GetFreqMoyKali();
EXTERNE float _stdcall GetFreqMoyKaliStd();
EXTERNE float _stdcall GetFreqMoyMultiKaliStd(short nK);

///////////////////
// Quitter Kali
///////////////////

//Sauve les paramtres actuels de Kali
EXTERNE void SauveInitKali();
EXTERNE void _stdcall SauveInitKaliStd();

//Indispensable quand on arrte un programme utilisant Kali
//ATTENTION : L'oubli de cette fonction peut crer une erreur obligeant  relancer le systme informatique
EXTERNE void ExitKali();
EXTERNE void _stdcall ExitKaliStd();


///////////////////////////////////////////////////////
// Accs aux caractristiques constantes de Kali
///////////////////////////////////////////////////////

//Volume
EXTERNE short _stdcall GetVolumeMinKaliStd();
EXTERNE short _stdcall GetVolumeMaxKaliStd();
EXTERNE short _stdcall GetVolumeIncKaliStd();	//incrment
EXTERNE short _stdcall GetVolumeDefautKaliStd();	//incrment

//Dbit
EXTERNE short _stdcall GetDebitMinKaliStd();
EXTERNE short _stdcall GetDebitMaxKaliStd();
EXTERNE short _stdcall GetDebitIncKaliStd();	//incrment
EXTERNE short _stdcall GetDebitDefautKaliStd();	//incrment

//Hauteur
EXTERNE short _stdcall GetHauteurMinKaliStd();
EXTERNE short _stdcall GetHauteurMaxKaliStd();
EXTERNE short _stdcall GetHauteurIncKaliStd();	//incrment
EXTERNE short _stdcall GetHauteurDefautKaliStd();	//incrment

////////////////////////////////////////////////////////////
//Fonctions avances (non documentes)
////////////////////////////////////////////////////////////

//Fonctions rglage fin de la prosodie
EXTERNE void _stdcall SetCoefVolumeKaliStd(int nouvCoef);
EXTERNE int _stdcall GetCoefVolumeKaliStd();
EXTERNE void _stdcall SetCoefDebitKaliStd(int nouvCoef);
EXTERNE int _stdcall GetCoefDebitKaliStd();
EXTERNE void _stdcall SetCoefHauteurKaliStd(int nouvCoef);
EXTERNE int _stdcall GetCoefHauteurKaliStd();
EXTERNE void _stdcall SetCoefDeclinaisonKaliStd(int nouvCoef);
EXTERNE int _stdcall GetCoefDeclinaisonKaliStd();
EXTERNE void _stdcall SetCoefAccentKaliStd(int nouvCoef);
EXTERNE int _stdcall GetCoefAccentKaliStd();
EXTERNE void _stdcall SetCoefAllongementKaliStd(int nouvCoef);
EXTERNE int _stdcall GetCoefAllongementKaliStd();
EXTERNE void _stdcall SetCoefHasardProsoNatKaliStd(int nouvCoef);
EXTERNE int _stdcall GetCoefHasardProsoNatKaliStd();
EXTERNE void _stdcall SetCoefHasardProsoNormKaliStd(int nouvCoef);
EXTERNE int _stdcall GetCoefHasardProsoNormKaliStd();

//Pour la plate-forme de dveloppement
EXTERNE unsigned char* _stdcall GetTexteAlphaTemoinKaliStd();
EXTERNE unsigned char* _stdcall GetTextePhonTemoinKaliStd();
EXTERNE char* _stdcall GetTexteContoursKaliStd();
EXTERNE void _stdcall SetSortieSonMultiKaliStd(short nK, bool sortieSon);
EXTERNE void _stdcall SetSortieWaveMultiKaliStd(short nK, bool sortieWave);
EXTERNE void _stdcall SetNomFichierWaveMultiKaliStd(short nK, char *nomFichierWave);
//Positionne l'option sortie buffer
EXTERNE void _stdcall SetSortieBufMultiKaliStd(short nK, bool sortieBuf);
//Retourne un pt sur le buffer de son, rcupre sa taille, la frq ch, le nb ch
//EXTERNE const short* _stdcall GetBufMultiKaliStd(short nK, long& taille, long& fEch, short& nbBits);
//Retourne un pt sur la structure du buffer de son, avec sa taille, la frq ch, le nb ch
typedef struct {
	int bits;
	int num_channels;
	int sample_rate;
	int num_samples;
	const signed short *samples;
} AudioTrackKali;
EXTERNE const AudioTrackKali* _stdcall GetBufMultiKaliStd(short nK);
EXTERNE void _stdcall SetSortieAnaKaliStd(bool sortieAna);
EXTERNE void _stdcall SetNomFichierAnaKaliStd(char *nomFicAna);
EXTERNE void _stdcall SetAnaTransKaliStd(bool anaTrans);
EXTERNE bool _stdcall GetAnaTransKaliStd();
//Vide la mmoire informationnelle (modle pragmatique)
EXTERNE void _stdcall VideMemInfoStd(short nK);

#ifdef LINUX
EXTERNE bool initGlobal();
EXTERNE bool initTrans();
EXTERNE bool initParle();
EXTERNE bool initAnalyse();
EXTERNE bool initKali();
EXTERNE bool quitteGlobal();
EXTERNE bool quitteTrans();
EXTERNE bool quitteParle();
EXTERNE bool quitteAnalyse();
#endif

#endif
